using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Sql;
using System.Data.SqlClient;
using System.Threading;

namespace SqlNotificationRequestEx
{
    /*
     *  -- need to manually provision service and queue
     *  create queue dbo.MyQueue 
     *  create service MyService -- service name is case-sensitive
     *     on queue dbo.MyQueue
     *     ([http://schemas.microsoft.com/SQL/Notifications/PostQueryNotification]) 
     * 
     * 
     * 
     * 
     */

    class Program
    {
       private static readonly string connstring = "server=.\\sqldev01;database=pubs;integrated security=sspi";

       static void Main(string[] args) {
         GetData();

       while (true)
         Thread.Sleep(0);
    }

   private static void GetData() 
   {
     using (SqlConnection conn = new SqlConnection(connstring)) 
     {
       SqlCommand cmd = new SqlCommand("select job_id, job_desc from dbo.jobs where job_id = 3", conn);

       SqlNotificationRequest not = new SqlNotificationRequest();
       not.Options = "service=MyService;local database=pubs";
       not.Timeout = int.MaxValue;
       not.UserData = Guid.NewGuid().ToString();

       cmd.Notification = not;

       conn.Open();
       cmd.ExecuteNonQuery();
       Console.WriteLine("Read completed at {0}", DateTime.Now);

       ThreadStart ts = new ThreadStart(WaitForNotification);
       Thread background = new Thread(ts);
       background.Start();

     }
   }

   private static void WaitForNotification() 
   {
     using (SqlConnection conn = new SqlConnection(connstring)) 
     {

       SqlCommand waiter = new SqlCommand(
           "waitfor(receive top(1) cast(message_body as xml) from dbo.MyQueue)", conn);
       waiter.CommandTimeout = 0;
       conn.Open();

       SqlTransaction tx = conn.BeginTransaction();
       waiter.Transaction = tx;

       using (SqlDataReader r = waiter.ExecuteReader())
         while (r.Read())
           Console.WriteLine("\n{0} received:\n{1}", DateTime.Now,
               r.GetSqlXml(0).Value);

       tx.Commit();

       GetData();
     }
   }
    }
}